# -*- coding: ISO-8859-1 -*-

##############################################################################
#
# Copyright (c) 2006 Alexis Roda. All Rights Reserved.
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful, but
# WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA
# 02111-1307, USA.
#
##############################################################################

"""

$Id: ziptool.py 52 2006-10-01 16:14:44Z alex $
"""

#__version__ = "$Id: ziptool.py 52 2006-10-01 16:14:44Z alex $".split(' ')[3]

import mimetypes

from AccessControl import ClassSecurityInfo
from Acquisition import aq_base
from DateTime import DateTime
from Globals import InitializeClass

from Products.CMFCore.ActionProviderBase import ActionProviderBase
from Products.CMFCore.utils import UniqueObject
from Products.CMFCore.utils import getToolByName

from Products.ziptool import ziptool
from Products.ziptool import permissions



class CMFZipTool(UniqueObject,
                 ziptool.ZipTool,
                 ActionProviderBase) :
    """CMFZipTool
    """

    security = ClassSecurityInfo()

    id = 'portal_ziptool'
    title = ''
    meta_type = "cmf ziptool"
    icon = 'www/tool.gif'

    manage_options = ActionProviderBase.manage_options \
                     + ()\
                     + ziptool.ZipTool.manage_options\

    def __init__(self) :
        """
        """
        self._folder_type = 'EZFolder'

    security.declarePrivate('_create_folder')
    def _create_folder(self, container, name) :
        type_ = getattr(aq_base(self), '_folder_type')
        pt = getToolByName(self, 'portal_types')
        pt.constructContent(type_, container, id=name)

    security.declarePrivate('_create_member')
    def _create_member(self, container, name, member) :
        ctr = getToolByName(self, 'content_type_registry')
        tt = getToolByName(self, 'portal_types')
        mimetype, encoding = mimetypes.guess_type(name)
        if mimetype is None :
            mimetype = 'application/octet-stream'

        body = member.read()
        type_ = ctr.findTypeName(name, mimetype, body)

        if type_ == 'EZFile' :
            tt.constructContent(type_, container, id=name,
                                file=body)
        elif type_ == 'EZImage' :
            tt.constructContent(type_, container, id=name,
                                file=body)
        elif type_ == 'EZ Document' :
            tt.constructContent(type_, container, id=name,
                                text=body,
                                text_format='html')
        else :
            raise ValueError('type not supported: %s' % type_)
        obj = getattr(container, name)
        obj.setTitle(name)
        obj.setExpirationDate(DateTime() - 1)


InitializeClass(CMFZipTool)

def manage_addCMFZipTool(container, REQUEST=None) :
    """
    """
    obj = CMFZipTool()
    container._setObject(obj.getId(), obj)
    if REQUEST is not None :
        return container.manage_main(container, REQUEST)

